'''
Created on 6 june 2018

@author: Steven Fletcher - INRIA - Institut Pasteur - InBio
'''
import os
import errno
import json
import logging
from MicroMator.FileManagement import logger, makedirs_

MODULE = 'DataManagement'

class Position():
    '''Class that regroups all info concerning 1 position
    '''
    def __init__(self, index, X, Y, Z, use=True, analyse=True, label=""):
        '''Args:
        index(int): index is the index of the postion in the list
        X(float): the X coordinate
        Y(float): the Y coordinate
        Z(float): the Z coordinate
        use(bool)(optional): if it's to be used in the acquisition loops
        analyse(bool)(optional): if it's to be used in the image analysis
        label(str)(optional): a string to label th position
        channel(list of str): a list of strings
        '''
        self.index = index
        self.X = X
        self.Y = Y
        self.Z = Z
        self.use = use
        self.analyse = analyse
        self.label = label
        self.channels = []

    def __str__(self):
        '''
        prints the object according to a specified format
        '''
        return 'Pos: {}, X: {}, Y: {}, Z: {}, Used: {}, Analyzed: {}, Label: {}'.format(self.index, self.X, self.Y, self.Z, self.use, self.analyse, self.label)


class AllPositions():
    '''Class that regroups all the methods related to positions
    '''
    def __init__(self, folder_manager_obj, mmversion='beta'):
        '''Args:
            folder_manager_obj(object): the instance of the Filer object
            posfile(bool): if False will generate a Position fom where the XYstage & FocusDrive is
            mmversion(): gamma, beta or 1.423 versions of micromanager
        '''
        self.folder_manager_obj = folder_manager_obj
        logging.basicConfig(filename=self.folder_manager_obj.micromator_log_path, level=logging.DEBUG, format='%(asctime)s : %(message)s', datefmt='%Y/%m/%d %I:%M:%S %p')
        self.posfile = None
        self.mmversion = mmversion
        while True:
            try:
                self.find_pos_file()
                break
            except FileNotFoundError:
                logger('No .pos file found, please make sure the .pos file is present', print_=False, module=MODULE)
                _ = input('No .pos file found, please make sure the .pos file is present then and press Enter when ready...')
        self.badchars = '{][]":,'
        self.positions = []

        if self.mmversion == "gamma":
            print('pos: gamma')
            self.position_reader_gamma()
        elif self.mmversion == 'beta' or self.mmversion == '1.4':
            print('pos: beta/1423')
            self.position_reader_beta()
        else:
            logger('Incorrect or unsupported micromanager version, please make sure the micromanger path include either gamma, beta or 1422/1423', 'error', module=MODULE)
        for position in self.positions:
            logger('{}'.format(position), module=MODULE)

    def find_pos_file(self):
        '''gets the positions file generated by saving the postions in Micromanager
        MUST be .pos and in protocols folder.
        '''
        posfilecount = 0
        for file_ in os.listdir(self.folder_manager_obj.protocols_path):
            if file_.endswith('.pos'):
                posfilecount += 1
                self.posfile = os.path.join(self.folder_manager_obj.protocols_path, file_)
                if posfilecount > 1:
                    logger('more than 1 position file present...selected the first one in the list', 'warning', module=MODULE)
        if not self.posfile:
            raise FileNotFoundError

    def position_reader_gamma(self):
        '''this method reasd json format .pos files and creates a Position object for each position found
        this method is for micromanager 2.0gamma branch
        '''
        label = '-'
        with open(self.posfile) as posfile:
            posdata = json.load(posfile)
            count = 0
            for position in posdata["map"]["StagePositions"]["array"]:
                for info in position:
                    if info == "DevicePositions":
                        info = position["DevicePositions"]["array"]
                        for device in info:
                            if device["Device"]["scalar"].lower() in ('focus', 'focusdrive', 'zstage', 'zdrive', 'adaptive focus control offset', 'z'):
                                posz = device["Position_um"]["array"][0]
                            elif device["Device"]["scalar"].lower() in ('xy stage', 'xystage', 'stage', 'xy'):
                                posx = device["Position_um"]["array"][0]
                                posy = device["Position_um"]["array"][1]
                    elif info == 'Label':
                        label = position[info]["scalar"]
                self.positions.append(Position(count, posx, posy, posz, label=label))
                self.posfilecreater(count)
                count += 1
            if count == 0:
                logger('No postions found in the .pos file', 'error', module=MODULE)

    def position_reader_beta(self):
        '''this method reads the json format .pos file and creates a Position object for each position found
        this method is for micromanager 2.0beta branch
        '''
        with open(self.posfile) as posfile:
            posdata = json.load(posfile)
            list_positions = posdata['POSITIONS']
            count = 0
            for position in list_positions:
                for device in position['DEVICES']:
                    if device['DEVICE'].lower() in ('xy stage', 'xystage', 'stage', 'dxystage'):
                        posx = device['X']
                        posy = device['Y']
                    elif device['DEVICE'].lower() in ('focus', 'focusdrive', 'zstage', 'zdrive', 'dstage'):
                        posz = device['X']
                self.positions.append(Position(count, posx, posy, posz))
                self.posfilecreater(count)
                count += 1
        if count == 0:
            logger('No postions found in the .pos file', 'error', module=MODULE)

    def posfilecreater(self, posnum): #move to folder creater? No because folder creater doesn't know how many pos ther will be
        '''this method creates the posposnum folder in Experiment/Acquisition folder
        Args:
            posnum(int): number of the position
        '''
        makedirs_("{}/pos{}".format(self.folder_manager_obj.acquisitions_path, posnum))
        makedirs_("{}/pos{}".format(self.folder_manager_obj.bitmaps_path, posnum))

    def __str__(self):
        '''prints the object according to a specified format
        '''
        for position in self.positions:
            print(position)
